/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */

#define WeakEncrKey "hjksrg%vhFD47tcb/(hj765ghfsa/&kawerhgfty<ag#sgfkrektIOjhrthkj4q"

class SessionUserSession;

enum war_auth_mode
{
	WARAUTH_LEVEL_100, // lowest level for RPC access
	WARAUTH_INVALID
};

enum war_auth_crypt_mode
{
	WARAC_NONE, // No encryption
	WARAC_LEVEL_100, // Weak encryption using fixed key
	WARAC_INVALID
};

struct war_auth_def_100
{
	war_auth_mode m_Mode;
	war_auth_crypt_mode m_EncrLevel;
	user m_User;
	hyper m_Handle;
	int m_Reserved;
};

#define WAR_AUT_DEF_100_CLEN\
 (sizeof(war_auth_def_100) - 8)

#define WAR_AUT_DEF_100_GLEN (sizeof(war_auth_def_100) / 4)

// Login request. The data here is encrypted
#define WAR_AUT_RPCLOGIN_100_PWDLEN 32
struct war_auth_rpclogin_100_def
{
	GCHAR m_Pwd[WAR_AUT_RPCLOGIN_100_PWDLEN];
};


void PrpAuthData_100(war_rpclogin_req& Req, 
	LPCSTR Name, LPCSTR Passwd, 
	user_node_type UserType = UT_USER, 
	war_svr_type ServerLogonType = WST_INVALID);
BOOL UnprpAuthData_100(war_rpclogin_req& Req);
BOOL UnprpAuthData(LPVOID Raw);
void PrpAuthData(war_auth_mode Mode, war_auth_crypt_mode Level, LPVOID Raw, SessionUserSession *pSUS);
void WarAuthConvertToGids(war_auth_def_100& ad, int gids[WAR_AUT_DEF_100_GLEN]);
void WarAuthConvertFromGids(war_auth_def_100& ad, int gids[WAR_AUT_DEF_100_GLEN]);
LPCSTR GetSystemThreadPassword();


