

class WarRpc : public WarSocket
{
public:
	WarRpc();
	~WarRpc();

	enum RPCTransport
	{
		RPCT_TUNNEL,
		RPCT_TCP,
		RPCT_UDP,
		RPCT_PIPE,
		RPCT_INVALID
	} m_Transport;

	enum RPCError
	{
		RPCE_OK,
		RPCE_XXX = MED_WAR_RPC,
		RPCE_INVALID
	} m_RPCErrno;
};


class WarRpcSvr : public WarRpc
{
public:
	WarRpcSvr();
	~WarRpcSvr();

	BOOL Create(LPCSTR Name, DWORD Program, DWORD Version, RPCTransport Transport, ...);
	void OnMessage(int Error);
};

class WarRpcClnt : public WarRpc
{
public:
	WarRpcClnt();
	~WarRpcClnt();
};

