/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */

// Mappings for the winsock API to allow the same binary
// to use winsock 1.1 and 2.x
//
// We also include the RAS API here as the program woun't start if we
// link this statically.

#ifdef WIN32

#ifndef EXTWLIB
#define EXTWLIB extern
#endif


#ifdef __cplusplus
extern "C" {
#endif

EXTWLIB SOCKET (PASCAL *__accept) (SOCKET s, struct sockaddr FAR *addr, int FAR *addrlen);
EXTWLIB int (PASCAL *__bind) (SOCKET s, const struct sockaddr FAR *addr, int namelen);
EXTWLIB int (PASCAL *__closesocket) (SOCKET s);
EXTWLIB int (PASCAL *__connect) (SOCKET s, const struct sockaddr FAR *name, int namelen);
EXTWLIB struct hostent FAR * (PASCAL *__gethostbyaddr)(const char FAR * addr, int len, int type);
EXTWLIB struct hostent FAR * (PASCAL *__gethostbyname)(const char FAR * name);
EXTWLIB int (PASCAL *__gethostname) (char FAR * name, int namelen);
EXTWLIB struct protoent FAR * (PASCAL *__getprotobyname)(const char FAR * name);
EXTWLIB struct protoent FAR * (PASCAL *__getprotobynumber)(int proto);
EXTWLIB struct servent FAR * (PASCAL *__getservbyname)(const char FAR * name, const char FAR * proto);
EXTWLIB struct servent FAR * (PASCAL *__getservbyport)(int port, const char FAR * proto);
EXTWLIB int (PASCAL *__getsockname) (SOCKET s, struct sockaddr FAR *name, int FAR * namelen);
EXTWLIB int (PASCAL *__getsockopt)(SOCKET s, int level, int optname, char FAR * optval, int FAR *optlen);
EXTWLIB u_long (PASCAL *__htonl)(u_long hostlong);
EXTWLIB u_short (PASCAL *__htons)(u_short hostshort);
EXTWLIB unsigned long (PASCAL *__inet_addr) (const char FAR * cp);
EXTWLIB char FAR * (PASCAL *__inet_ntoa)(struct in_addr in);
EXTWLIB int (PASCAL *__listen)(SOCKET s, int backlog);
EXTWLIB u_long (PASCAL *__ntohl)(u_long netlong);
EXTWLIB int (PASCAL *__recv)(SOCKET s, char FAR * buf, int len, int flags);
EXTWLIB int (PASCAL *__recvfrom)(SOCKET s, char FAR * buf, int len, int flags, struct sockaddr FAR *from, int FAR * fromlen);
EXTWLIB int (PASCAL *__select)(int nfds, fd_set FAR *readfds, fd_set FAR *writefds, fd_set FAR *exceptfds, const struct timeval FAR *timeout);
EXTWLIB int (PASCAL *__send)(SOCKET s, const char FAR * buf, int len, int flags);
EXTWLIB int (PASCAL *__sendto)(SOCKET s, const char FAR * buf, int len, int flags,  const struct sockaddr FAR *to, int tolen);
EXTWLIB int (PASCAL *__setsockopt)(SOCKET s, int level, int optname,const char FAR * optval, int optlen);
EXTWLIB int (PASCAL *__shutdown)(SOCKET s, int how);
EXTWLIB SOCKET (PASCAL *__socket)(int af, int type, int protocol);
EXTWLIB HANDLE (PASCAL *__WSAAsyncGetHostByAddr)(HWND *hWnd, u_int wMsg,const char FAR * addr, int len, int type,char FAR * buf, int buflen);
EXTWLIB HANDLE (PASCAL *__WSAAsyncGetHostByName)(HWND *hWnd, u_int wMsg,const char FAR * name, char FAR * buf,int buflen);
EXTWLIB HANDLE (PASCAL *__WSAAsyncGetProtoByName)(HWND *hWnd, u_int wMsg,const char FAR * name, char FAR * buf,int buflen);
EXTWLIB HANDLE (PASCAL *__WSAAsyncGetProtoByNumber)(HWND *hWnd, u_int wMsg,int number, char FAR * buf,int buflen);
EXTWLIB HANDLE (PASCAL *__WSAAsyncGetServByName)(HWND *hWnd, u_int wMsg,const char FAR * name,const char FAR * proto,char FAR * buf, int buflen);
EXTWLIB HANDLE (PASCAL *__WSAAsyncGetServByPort)(HWND *hWnd, u_int wMsg, int port,const char FAR * proto, char FAR * buf,int buflen);
EXTWLIB int (PASCAL *__WSAAsyncSelect)(SOCKET s, HWND *hWnd, u_int wMsg,long lEvent);
EXTWLIB int (PASCAL *__WSACleanup)(void);
EXTWLIB int (PASCAL *__WSAGetLastError)(void);
EXTWLIB void (PASCAL *__WSASetLastError)(int iError);
EXTWLIB int (PASCAL *__WSAStartup)(WORD wVersionRequired, LPWSADATA lpWSAData);
EXTWLIB int (PASCAL *__getpeername)(SOCKET s,struct sockaddr FAR * name,int FAR * namelen);
EXTWLIB int (PASCAL *__ioctlsocket)(SOCKET s,long cmd,u_long FAR * argp);
EXTWLIB u_short (PASCAL *__ntohs)(u_short netshort);
EXTWLIB int (PASCAL *__WSACancelAsyncRequest)(HANDLE hAsyncTaskHandle);
EXTWLIB int (PASCAL *____WSAFDIsSet)(SOCKET, fd_set FAR *);

// Winsock 2
EXTWLIB int (PASCAL *__WSARecvEx)(SOCKET s, char FAR * buf, int len, int FAR *flags);
EXTWLIB BOOL (PASCAL *__AcceptEx) (
    IN SOCKET sListenSocket,
    IN SOCKET sAcceptSocket,
    IN PVOID lpOutputBuffer,
    IN DWORD dwReceiveDataLength,
    IN DWORD dwLocalAddressLength,
    IN DWORD dwRemoteAddressLength,
    OUT LPDWORD lpdwBytesReceived,
    IN LPOVERLAPPED lpOverlapped
    );

EXTWLIB int (PASCAL *__WSAIoctl)(
    SOCKET s,
    DWORD dwIoControlCode,
    LPVOID lpvInBuffer,
    DWORD cbInBuffer,
    LPVOID lpvOutBuffer,
    DWORD cbOutBuffer,
    LPDWORD lpcbBytesReturned,
    LPWSAOVERLAPPED lpOverlapped,
    LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
    );


EXTWLIB INT (PASCAL *__EnumProtocols) (
    IN     LPINT           lpiProtocols,
    IN OUT LPVOID          lpProtocolBuffer,
    IN OUT LPDWORD         lpdwBufferLength
    );


#ifdef __cplusplus
}
#endif 

// RAS
#include "ras.h"
#define RasEnumConnectionsA __RasEnumConnectionsA
#define RasGetProjectionInfoA __RasGetProjectionInfoA
#define RasGetErrorStringA __RasGetErrorStringA

EXTWLIB DWORD (PASCAL *__RasEnumConnectionsA)(LPRASCONNA, LPDWORD, LPDWORD); 
EXTWLIB DWORD (PASCAL *__RasGetProjectionInfoA)(HRASCONN, RASPROJECTION, LPVOID, LPDWORD);
EXTWLIB DWORD (PASCAL *__RasGetErrorStringA)(UINT, LPSTR, DWORD);

#endif // WIN32

 