/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
#if !defined(AFX_LOGINPERMSCNTR_H__DD6113C3_6E1F_11D1_9850_00609765EF85__INCLUDED_)
#define AFX_LOGINPERMSCNTR_H__DD6113C3_6E1F_11D1_9850_00609765EF85__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// LoginPermsCntr.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// LoginPermsCntr dialog

class LoginPermsCntr : public CDialog
{
// Construction
public:
	LoginPermsCntr(CWnd* pParent, 
		UserMgrDlg *pUserMgrDlg,
		wdq_mode ReqMode, 
		int MinValue, int MaxValue,
		LPCSTR LabelText);

// Dialog Data
	//{{AFX_DATA(LoginPermsCntr)
	enum { IDD = IDD_LOGIN_PERMS_CNTR };
	LevelIndicator	m_ctlLevelIndicator;
	CSliderCtrl	m_ctlSlider;
	CEdit	m_ctlValue;
	int		m_Value;
	int		m_Mode;
	//}}AFX_DATA

	int m_MinValue;
	int m_MaxValue;
	BOOL m_bIsInitialized;
	UserMgrDlg *m_pUserMgrDlg;
	wdq_mode m_ReqMode;
	CString m_LabelText;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(LoginPermsCntr)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void UpdateFromSlider(UINT nSBCode);

	// Generated message map functions
	//{{AFX_MSG(LoginPermsCntr)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeMode();
	afx_msg void OnKillfocusValue();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	virtual void OnCancel();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LOGINPERMSCNTR_H__DD6113C3_6E1F_11D1_9850_00609765EF85__INCLUDED_)
 