/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
#if !defined(AFX_USERDACCOUNTSTATUS_H__11707354_6C92_11D1_984F_00609765EF85__INCLUDED_)
#define AFX_USERDACCOUNTSTATUS_H__11707354_6C92_11D1_984F_00609765EF85__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// UserDAccountStatus.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// UserDAccountStatus dialog

class UserDAccountStatus : public CDialog
{
// Construction
public:
	UserDAccountStatus(CWnd* pParent = NULL);   // standard constructor
	void OnOK();
	void OnCancel();

// Dialog Data
	//{{AFX_DATA(UserDAccountStatus)
	enum { IDD = IDD_USRD_LOGIN };
	PathList	m_ctlAccessList;
	LevelIndicator	m_ctlUserTypeLevel;
	CButton	m_ctlChangePwdButton;
	CButton	m_ctlValidateEmail;
	int		m_UserType;
	int		m_PasswdMode;
	BOOL	m_bValidateEmail;
	//}}AFX_DATA

	BOOL m_bIsInitialized;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(UserDAccountStatus)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void UpdateEnabled();

	// Generated message map functions
	//{{AFX_MSG(UserDAccountStatus)
	afx_msg void OnChangepwd();
	afx_msg void OnPwdChange();
	afx_msg void OnUserTypeChange();
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkAccesslist(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_USERDACCOUNTSTATUS_H__11707354_6C92_11D1_984F_00609765EF85__INCLUDED_)
 
