/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */


class WarArgs
{
public:
	int m_argc;
	LPSTR *m_argv;
	int m_argc_max;
	BOOL IsReInitialized;

public:
	WarArgs();
	//WarArgs(LPCSTR Name, LPCSTR CommandLine, CCommandParser& Parser);
	~WarArgs();
	LPCSTR AddArg(LPCSTR Arg, int Len = 0);
	LPCSTR Arg(int Index);
	void PrepereNew();
	LPCSTR Insert(int Index, LPCSTR Arg, int Len = 0);
	LPCSTR Replace(int Index, LPCSTR Arg, int Len = 0);
	int operator = (WarArgs& Arg);
	LPCSTR operator [] (int n) {return Arg(n); }
	void operator += (LPCSTR Str) {AddArg(Str); }
	BOOL CrunchPath(LPCSTR Path);

private:
	void Empty();
	void Initialize();
	void Check();
};

