/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */

// C level support functions for user data structures
void Clear(user_node_type& Val);
void Clear(user_pwd& Val);
void Clear(user_info& Val);
void Clear(user_expiery& Val);
void Clear(user_fs_access_list **Val); // Deletes the tree
void Clear(ip_access& Val);
void Clear(ip_access_list **Val);
void Clear(user_perm_id& Val);
void Clear(war_daemon_info& Val);
void Clear(user_greeting& Val);
void Clear(user_stat& Val);
void Clear(ud_restrictions& Val);
void Clear(user_subclass_data& Val);
void Clear(user_login_perms& Val);
void Clear(fs_dup& Val);
void Clear(user_fs_access& Val);
void Clear(war_user_data& Val);
void Clear(war_ftp_user_data& Val);
void Clear(user_priv_type& Val);
void Clear(user_login_access& Val);
void Clear(user_login_time_t& Val);
void Clear(war_nt_domain& Val);
void Clear(user_fsys_paths& Val);

void Null(user_subclass_data& Val);
void Null(user_node_type& Val);
void Null(user_pwd& Val);
void Null(user_info& Val);
void Null(user_expiery& Val);
void Null(ip_access& Val);
void Null(user_perm_id& Val);
void Null(war_daemon_info& Val);
void Null(user_greeting& Val);
void Null(user_stat& Val);
void Null(ud_restrictions& Val);
void Null(user_subclass_data& Val);
void Null(user_login_perms& Val);
void Null(fs_dup& Val);
void Null(user_fs_access& Val);
void Null(war_user_data& Val);
void Null(user_priv_type& Val);
void Null(user_login_access& Val);
void Null(user_login_time_t& Val);
void Null(war_nt_domain& Val);
void Null(user_fsys_paths& Val);

BOOL Serialize(user_subclass_data& Val, WarArchive& ar);
BOOL Serialize(user_node_type& Val, WarArchive& ar);
BOOL Serialize(user_pwd& Val, WarArchive& ar);
BOOL Serialize(user_info& Val, WarArchive& ar);
BOOL Serialize(user_expiery& Val, WarArchive& ar);
BOOL Serialize(ip_access& Val, WarArchive& ar);
BOOL Serialize(user_perm_id& Val, WarArchive& ar);
BOOL Serialize(war_daemon_info **Val, WarArchive& ar);
BOOL Serialize(user_greeting& Val, WarArchive& ar);
BOOL Serialize(user_stat& Val, WarArchive& ar);
BOOL Serialize(ud_restrictions& Val, WarArchive& ar);
BOOL Serialize(user_subclass_data& Val, WarArchive& ar);
BOOL Serialize(user_login_perms& Val, WarArchive& ar);
BOOL Serialize(fs_dup& Val, WarArchive& ar);
BOOL Serialize(user_fs_access& Val, WarArchive& ar);
BOOL Serialize(war_user_data& Val, WarArchive& ar);
BOOL Serialize(user_login_t& Val, WarArchive& ar);
BOOL Serialize(war_ftp_user_data& Val, WarArchive& ar);
BOOL Serialize(user_fs_access_list **Val, WarArchive& ar);
BOOL Serialize(user_login_time_t& Val, WarArchive& ar);
BOOL Serialize(user_fsys_paths& Val, WarArchive& ar);
BOOL Serialize(user_priv_type& Val, WarArchive& ar);
BOOL Serialize(user_login_access& Val, WarArchive& ar);

