/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */


const LOG_PROGNLEN	= 16;
const LOG_SCKNLEN		= 64;
const LOG_TEXTLEN		= 256;
const LOG_MODLEN		= 64;

typedef string progname<LOG_PROGNLEN>; 
typedef string logtext<LOG_TEXTLEN>;
typedef string sockname<LOG_SCKNLEN>;
typedef string logmodule<LOG_MODLEN>;

struct WarLogHdr
{
	hyper m_Time;
	progname m_ProgramName;
	unsigned m_Type; 
	hyper m_UserNo; 
	sockname m_SckName;
	int m_SystemErrno;
	int m_ProgramErrno;
	logmodule m_Module;
	logtext m_SystemErrText;
	logtext m_Text;
};

program WARLOGD_PROGRAM 
{
	version WARLOGD_VERSION 
	{
		void NFSPROC_NULL(void) = 0;
		void LOGD_LOGIT(WarLogHdr) = 1;
	} = 1;
} = 352251;
 