/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */
#if !defined(AFX_USERDGREETING_H__1F465F31_738F_11D1_9853_00609765EF85__INCLUDED_)
#define AFX_USERDGREETING_H__1F465F31_738F_11D1_9853_00609765EF85__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// UserDGreeting.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// UserDGreeting dialog

class UserDGreeting : public CDialog
{
// Construction
public:
	DECLARE_DYNCREATE(UserDGreeting)
	UserDGreeting(CWnd* pParent = NULL);   // standard constructor
	void OnOK();
	void OnCancel();
	void SaveData();
	void LoadData();
	void OnTab();
	void OnDate();

// Dialog Data
	//{{AFX_DATA(UserDGreeting)
	enum { IDD = IDD_USER_GREETING };
	CEdit	m_ctlEffectiveMessage;
	CButton	m_ctlUseDate;
	CTabCtrl	m_ctlTab;
	CButton	m_ctlDelete;
	CEdit	m_ctlEdit;
	CString	m_Message;
	BOOL	m_bDeleteWhenDisplayed;
	BOOL	m_bUseDate;
	//}}AFX_DATA

	CalendarCntr *m_pCal;

	CString	m_sMessage;
	BOOL m_bIsInitialized;
	BOOL m_bDoSave;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(UserDGreeting)
	public:
	virtual void OnFinalRelease();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(UserDGreeting)
	virtual BOOL OnInitDialog();
	afx_msg void OnDelete();
	afx_msg void OnKillfocusEdit();
	afx_msg void OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnUsedate();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_USERDGREETING_H__1F465F31_738F_11D1_9853_00609765EF85__INCLUDED_)
 
