/* !!Copyright begin */
/*
War Software series
Copyright (C) 1996 - 1998 by Jarle (jgaa) Aase (www.jgaa.com)
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License - WITH THE FOLLOWING RESTRICTIONS:

  * GOVERNMENTS, GOVERNMENTAL AGENCIES OR COMMERCIAL 
    COMPANIES OWNED 50% OR MORE BY THE GOVERNMENT ARE
    NOT ALLOWED TO USE THE SOFTWARE OR SORCE CODE FOR
    ANY PURPOSE. THIS RESTRICTION ALSO APPLIES FOR
    PROGRAMS DERIVED FROM THE SOURCE CODE, OR PROGRAMS/
    SOURCE CODE THAT USE SPECIAL TECHNICS/ALOGRITHMS
    INVENTED IN THIS SOFTWARE.

  * THE FULL SOURCE CODE IS WITHELD FROM A PUBLIC RELEASE
    UNTIL THE LINUX VERISON IS RELEASED.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
/* !!Copyright end */

// Used by WarPmapSvc.cpp and modules
// using the WarPortmap class



class WarPortmap
{
public:
	WarPortmap();
	~WarPortmap();

	BOOL Create();
	BOOL Register(mapping& Map, WarSocket *pSock = NULL);
	BOOL DoRegister(mapping& Map);
	BOOL Unregister(mapping& Map, WarSocket *pSock = NULL);
	BOOL DoUnregister(mapping& Map);
	pmap_pmaplist *Find(mapping& Map);
	pmap_pmaplist *m_pRootMap;
	static LPCSTR GetProgName(DWORD ProgNo);

	WarSvrUdpSocket *m_pUDP;
	
	enum ErrorCodesDef
	{
		PMAP_NO_ERROR,
		PMAP_EXIST = MED_WAR_PORTMAP, // Service is already registered
		PMAP_NOT_FOUND,
		PMAP_FAILED_TO_REGISTER,
		PMAP_FAILED_TO_START,
		PMAP_INVALID
	} m_Errno;
	
};

